diff -ruN freeswan-1.9.orig/pluto/kernel.h freeswan-1.9/pluto/kernel.h
--- freeswan-1.9.orig/pluto/kernel.h	Tue Jan 23 18:09:30 2001
+++ freeswan-1.9/pluto/kernel.h	Wed May 16 10:57:20 2001
@@ -11,7 +11,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: kernel.h,v 1.18 2001/01/23 23:09:30 dhr Exp $
+ * RCSID $Id: kernel.h,v 1.19 2001/05/08 05:37:23 dhr Exp $
  */
 
 extern bool no_klips;	/* don't actually use KLIPS */
diff -ruN freeswan-1.9.orig/pluto/kernel_comm.c freeswan-1.9/pluto/kernel_comm.c
--- freeswan-1.9.orig/pluto/kernel_comm.c	Tue Jan 23 18:09:30 2001
+++ freeswan-1.9/pluto/kernel_comm.c	Wed May 16 10:57:20 2001
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: kernel_comm.c,v 1.53 2001/01/23 23:09:30 dhr Exp $
+ * RCSID $Id: kernel_comm.c,v 1.57 2001/05/08 05:37:23 dhr Exp $
  */
 
 #include <stdio.h>
@@ -46,7 +46,7 @@
 
 /* helper variables and function to decode strings from whack message */
 
-static char
+static char 
     *next_str,
     *str_roof;
 
@@ -97,21 +97,21 @@
     /* sanity check message */
     {
 	int ughno = RC_BADWHACKMESSAGE;
-	char ugh[200];	/* sufficient for our messages (we hope) */
+	char ugh[200];  /* sufficient for our messages (we hope) */
 
 	next_str = msg.string;
 	str_roof = (char *)&msg + n;
 
 	if (next_str > str_roof)
 	{
-	    snprintf(ugh, sizeof(ugh)
-		, "truncated message from whack: got %d bytes; expected %d.  Message ignored."
+           snprintf(ugh, sizeof(ugh)
+               , "truncated message from whack: got %d bytes; expected %d.  Message ignored."
 		, n, (int) sizeof(msg));
 	}
 	else if (msg.magic != WHACK_MAGIC)
 	{
 	    snprintf(ugh, sizeof(ugh)
-		, "message from whack has bad magic %d; should be %d; probably wrong version.  Message ignored"
+               , "message from whack has bad magic %d; should be %d; probably wrong version.  Message ignored"
 		, msg.magic, WHACK_MAGIC);
 	}
 	else if (!unpack_str(&msg.name)	/* string 1 */
@@ -122,13 +122,12 @@
 	|| !unpack_str(&msg.keyid)	/* string 6 */
 	|| str_roof - next_str != (ptrdiff_t)msg.keyval.len)	/* check chunk */
 	{
-	    snprintf(ugh, sizeof(ugh)
-		, "message from whack contains bad string");
+	    snprintf(ugh, sizeof(ugh), "message from whack contains bad string");
 	}
 	else
 	{
 	    msg.keyval.ptr = next_str;	/* grab chunk */
-	    ughno = 0;	/* ran through the gauntlet -- success */
+	    ughno = 0;  /* ran through the gauntlet -- success */
 	}
 
 	if (ughno != 0)
@@ -149,8 +148,8 @@
 	     * cause the message to print, it will be printed.
 	     */
 	    cur_debugging |= msg.debugging;
-	    DBG(DBG_CONTROL,
-		DBG_log("base debugging = %s"
+	    DBG(DBG_CONTROL
+		, DBG_log("base debugging = %s"
 		    , bitnamesof(debug_bit_names, msg.debugging)));
 	    cur_debugging = base_debugging = msg.debugging;
 	}
@@ -161,8 +160,8 @@
 	    if (c != NULL)
 	    {
 		c->extra_debugging = msg.debugging;
-		DBG(DBG_CONTROL,
-		    DBG_log("\"%s\" extra_debugging = %s"
+		DBG(DBG_CONTROL
+		    , DBG_log("\"%s\" extra_debugging = %s"
 			, c->name
 			, bitnamesof(debug_bit_names, c->extra_debugging)));
 	    }
@@ -244,10 +243,10 @@
 	    if (c != NULL)
 	    {
 		SET_CUR_CONNECTION(c);
-		if (!orient(c, TRUE))
-		    whack_log(RC_ORIENT, "could not orient connection");
-		else if (!route_connection(c, TRUE))
-		    whack_log(RC_ROUTE, "could not route");
+                if (!orient(c, TRUE))
+                   whack_log(RC_ORIENT, "could not orient connection");
+                else if (!route_connection(c, TRUE))
+		   whack_log(RC_ROUTE, "could not route");
 		UNSET_CUR_CONNECTION();
 	    }
 	}
diff -ruN freeswan-1.9.orig/pluto/log.h freeswan-1.9/pluto/log.h
--- freeswan-1.9.orig/pluto/log.h	Tue Sep 12 02:59:29 2000
+++ freeswan-1.9/pluto/log.h	Wed May 16 10:57:20 2001
@@ -11,7 +11,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: log.h,v 1.23 2000/09/12 06:59:29 dhr Exp $
+ * RCSID $Id: log.h,v 1.26 2001/05/05 17:20:01 dhr Exp $
  */
 
 #include <freeswan.h>
diff -ruN freeswan-1.9.orig/pluto/main.c freeswan-1.9/pluto/main.c
--- freeswan-1.9.orig/pluto/main.c	Tue Jan 23 18:09:31 2001
+++ freeswan-1.9/pluto/main.c	Wed May 16 10:57:20 2001
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: main.c,v 1.40 2001/01/23 23:09:31 dhr Exp $
+ * RCSID $Id: main.c,v 1.41 2001/03/13 09:22:05 dhr Exp $
  */
 
 #include <stdio.h>
@@ -29,6 +29,11 @@
 
 #include <freeswan.h>
 
+#ifdef OPENSSL
+#include <openssl/evp.h>
+#include <openssl/err.h>
+#endif
+
 #include "constants.h"
 #include "defs.h"
 #include "id.h"
@@ -42,6 +47,20 @@
 #include "rnd.h"
 #include "state.h"
 
+#ifdef OPENSSL
+#include "openssl.h"
+#include "xmap_dir.h"
+#include "xmap_file.h"
+#ifdef HAVE_DB
+#include "xmap_db.h"
+#endif
+#ifdef HAVE_LDAP
+#include "xmap_ldap.h"
+#endif
+#include "xmap.h"
+
+#endif /* OPENSSL */
+
 #include "sha1.h"
 #include "md5.h"
 #include "crypto.h"	/* requires sha1.h and md5.h */
@@ -158,6 +177,21 @@
     bool log_to_stderr_desired = FALSE;
     int lockfd;
 
+#ifdef OPENSSL
+    SSLeay_add_all_algorithms();
+    X509V3_add_standard_extensions();
+    ERR_load_crypto_strings();
+    ERR_load_ElGamal_strings();
+    XMAP_register(XMAP_METHOD_file());
+    XMAP_register(XMAP_METHOD_dir());
+#ifdef HAVE_DB
+    XMAP_register(XMAP_METHOD_db());
+#endif /* HAVE_DB */
+#ifdef HAVE_LDAP
+    XMAP_register(XMAP_METHOD_ldap());
+#endif /* HAVE_LDAP */
+#endif
+
     /* handle arguments */
     for (;;)
     {
@@ -417,6 +451,10 @@
 #ifdef LEAK_DETECTIVE
     report_leaks();
 #endif /* LEAK_DETECTIVE */
+#ifdef OPENSSL
+    X509V3_EXT_cleanup();
+    ERR_free_strings();
+#endif
     close_log();
     exit(status);
 }
diff -ruN freeswan-1.9.orig/pluto/md5.c freeswan-1.9/pluto/md5.c
--- freeswan-1.9.orig/pluto/md5.c	Sat Dec 11 20:31:36 1999
+++ freeswan-1.9/pluto/md5.c	Wed May 16 10:57:20 2001
@@ -139,7 +139,11 @@
 /* MD5 initialization. Begins an MD5 operation, writing a new context.
  */
 void MD5Init (context)
+#ifndef OPENSSL
 MD5_CTX *context;                                        /* context */
+#else
+PLUTO_MD5_CTX *context;                                  /* context */
+#endif
 {
   context->count[0] = context->count[1] = 0;
   /* Load magic initialization constants.
@@ -155,7 +159,11 @@
   context.
  */
 void MD5Update (context, input, inputLen)
+#ifndef OPENSSL
 MD5_CTX *context;                                        /* context */
+#else
+PLUTO_MD5_CTX *context;                                  /* context */
+#endif
 unsigned char *input;                                /* input block */
 UINT4 inputLen;                            /* length of input block */
 {
@@ -194,7 +202,11 @@
  */
 void MD5Final (digest, context)
 unsigned char digest[16];                         /* message digest */
-MD5_CTX *context;                                       /* context */
+#ifndef OPENSSL
+MD5_CTX *context;                                 /* context */
+#else
+PLUTO_MD5_CTX *context;
+#endif /* OPENSSL */
 {
   unsigned char bits[8];
   unsigned int index, padLen;
diff -ruN freeswan-1.9.orig/pluto/md5.h freeswan-1.9/pluto/md5.h
--- freeswan-1.9.orig/pluto/md5.h	Sat Dec 11 20:31:36 1999
+++ freeswan-1.9/pluto/md5.h	Wed May 16 10:57:20 2001
@@ -61,11 +61,22 @@
   UINT4 state[4];                                   /* state (ABCD) */
   UINT4 count[2];        /* number of bits, modulo 2^64 (lsb first) */
   unsigned char buffer[64];                         /* input buffer */
+#ifndef OPENSSL
 } MD5_CTX;
+#else
+} PLUTO_MD5_CTX;
+#endif /* OPENSSL */
 
+#ifndef OPENSSL
 void MD5Init PROTO_LIST ((MD5_CTX *));
 void MD5Update PROTO_LIST
   ((MD5_CTX *, unsigned char *, UINT4));
 void MD5Final PROTO_LIST ((unsigned char [16], MD5_CTX *));
+#else
+void MD5Init PROTO_LIST ((PLUTO_MD5_CTX *));
+void MD5Update PROTO_LIST
+  ((PLUTO_MD5_CTX *, unsigned char *, unsigned int));
+void MD5Final PROTO_LIST ((unsigned char [16], PLUTO_MD5_CTX *));
+#endif /* OPENSSL */
 
 #define _MD5_H_
